/*
 * Copyright (c) 2012 Veselin Georgiev
 *
 * Cutting the bullshit:
 *  all sources here are free software; you can use them for everything you
 *  want. Just don't blame me if something goes wrong; if something happens
 *  (including, but not limited to:
 *     coredumps, formatted harddrives, ping timeouts, winamp sound skips,
 *     fried CPUs, sudden mother-in-law visits, fraglimits, viagra spam,
 *     raytracing courses, Stroeja zaporkings, Gogov getting drunk,
 *     Pesho chatting up romanian girls in the subway, incorrect global
 *     illumination, barking dogs, earthquakes, frog rain, Windows Vista
 *     installations, anrieff dingling on the bass guitar, dangerous sporks,
 *     apocalypse, concrete donkey, or even Genadzi Karatkevich getting your
 *     butt kicked...
 *  ), then you know you have been warned.
 *
 *
 *=======[ Quote of the Month: ]=======
 *
 * Going to Iran is almost as scary as knowing that the organizers are
 * primarily occupied with making Salam :)
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;

///////////////////////////////////////////////////////////////////////////////////
/////////////////////////////// System stuff //////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
#ifdef _WIN32
#include <windows.h>
double btime() { static bool inited = false; static DWORD clk0; if (!inited) { inited = true; clk0 = GetTickCount(); return 0.0; } return (GetTickCount() - clk0)*0.001; }
#else
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
double btime() {static bool inited = false;static int secs, usecs;struct timeval tv;if (!inited) {inited = true;gettimeofday(&tv, NULL);secs = tv.tv_sec;usecs = tv.tv_usec;return 0.0;}gettimeofday(&tv, NULL);return tv.tv_sec - secs + (tv.tv_usec - usecs)*0.000001;}
#endif

#define FOR(i,n) for (int i = 0; i < n; i++)
#define abs(x) ((x)<0?(-(x)):(x))
#define REP(i,v) for (unsigned i = 0; i < v.size(); i++)
#define RL(i,v) for (unsigned i = 0; i < v.length(); i++)
typedef long long ll;

const char* INFILE = "parash.in";
const char* OUTFILE= "parash.out";
const double TIME_LIMIT = 1.5;
const double TIME_LIMIT_2 = 1.88;

struct Person {
	int minval, div, w, h;
	bool mask[10][10];
	int numOnes;
};

struct SolEntry {
	int who, sx, sy;
	SolEntry() {}
	SolEntry(int who, int sx, int sy): who(who), sx(sx), sy(sy) {}
};

int W, H;
int a[64][64], saved_a[64][64];
vector<Person> persons;
vector<SolEntry> bestSolution, bestSrc;
int bestScore;

void input(void)
{
	FILE* f = fopen(INFILE, "rt");
	int np;
	fscanf(f, "%d%d%d", &H, &W, &np);
	FOR(i, H) FOR(j, W) fscanf(f, "%d", &a[i][j]);
	memcpy(saved_a, a, sizeof(saved_a));
	FOR(ki, np) {
		Person p;
		p.numOnes = 0;
		fscanf(f, "%d%d%d%d", &p.h, &p.w, &p.div, &p.minval);
		FOR(i, p.h) {
			char s[32];
			fscanf(f, "%s", s);
			FOR(j, p.w) {
				p.mask[i][j] = s[j] == '1';
				p.numOnes += (s[j] == '1');
			}
		}
		persons.push_back(p);
	}
	fclose(f);
}

void output(void)
{
	FILE* f = fopen(OUTFILE, "wt");
	//
	fprintf(f, "%d\n", (int) bestSolution.size());
	REP(i, bestSolution) {
		const SolEntry& e = bestSolution[i];
		fprintf(f, "%d %d %d\n", e.who + 1, e.sy + 1, e.sx + 1);
	}
	//
	fclose(f);
}

bool canApply(const Person& p, int sx, int sy)
{
	if (sx < 0 || sy < 0 || sx + p.w > W || sy + p.h > H) return false;
	FOR(y, p.h) FOR(x, p.w)
		if (p.mask[y][x] && a[sy + y][sx + x] < p.minval) return false;
	return true;
}

int apply(const Person& p, int sx, int sy)
{
	int sum = 0;
	FOR(y, p.h) FOR(x, p.w) if (p.mask[y][x]) {
		sum += a[sy + y][sx + x];
		a[sy + y][sx + x] /= p.div;
	}
	return sum;
}

struct Offset {
	int x, y;
	bool operator < (const Offset& rhs) const {
		return (x*x + y*y) < (rhs.x * rhs.x + rhs.y * rhs.y);
	}
};

vector<Offset> offs;
const int OL = 5;

void attempt(vector<SolEntry> S, bool final)
{
	vector<SolEntry> candidate;
	memcpy(a, saved_a, sizeof(a));
	int score = 0;
	REP(i, S) {
		REP(o, offs) 
			if (canApply(persons[S[i].who], S[i].sx + offs[o].x, S[i].sy + offs[o].y)) {
				S[i].sx += offs[o].x;
				S[i].sy += offs[o].y;
				score += apply(persons[S[i].who], S[i].sx, S[i].sy);
				candidate.push_back(S[i]);
				break;
			}
	}
	if (score > bestScore) {
		bestScore = score;
		bestSolution = candidate;
		if (!final) bestSrc = S;
#ifdef DEBUG
		printf("%s score (%6d) through order { ", final ? "Final" : "Best", score);
		REP(i, candidate) {
			if (i) printf(", ");
			printf("%d", candidate[i].who);
		}
		printf(" } (%2d items)\n", (int) candidate.size());
#endif
	}

}

void solve(void)
{
	for (int dy = -OL; dy <= OL; dy++)
		for (int dx = -OL; dx <= OL; dx++) {
			Offset of = {dx, dy};
			offs.push_back(of);
		}
	stable_sort(offs.begin(), offs.end());
	vector<pair<int, int> > minOrder(persons.size());
	REP(i, persons) minOrder[i] = make_pair(persons[i].numOnes * persons[i].div, i);
	stable_sort(minOrder.begin(), minOrder.end());
	int maxSwaps = (int) pow((double) persons.size(), 1.5);
	while (btime() < TIME_LIMIT) {
		vector<SolEntry> S(persons.size());
		REP(i, persons) {
			S[i].who = minOrder[i].second;
			S[i].sx = rand() % (W - persons[i].w + 1);
			S[i].sy = rand() % (H - persons[i].h + 1);
		}
		//random_shuffle(S.begin(), S.end());
		int nSwaps = rand() % maxSwaps;
		FOR(si, nSwaps) {
			int x = rand() % S.size();
			int y = rand() % S.size();
			swap(S[x], S[y]);
		}
		//
		attempt(S, false);
	}
	while (btime() < TIME_LIMIT_2) {
		random_shuffle(bestSrc.begin(), bestSrc.end());
		attempt(bestSrc, true);
	}
}

int main(void)
{
	btime();
	input();
	solve();
	output();
	return 0;
}
